package com.bergerkiller.bukkit.nolagg.itemstacker;

import java.util.LinkedHashSet;
import java.util.List;

import net.minecraft.server.*;

public class WorldEntityWatcher implements IWorldAccess {

	/*
	 * A bunch of unused listener functions
	 */
	public void a(int arg0, int arg1, int arg2) {}
	public void a(String arg0, int arg1, int arg2, int arg3) {}
	public void a(int arg0, int arg1, int arg2, TileEntity arg3) {}
	public void a(int arg0, int arg1, int arg2, int arg3, int arg4, int arg5) {}
	public void a(String arg0, double arg1, double arg2, double arg3, float arg4, float arg5) {}
	public void a(EntityHuman arg0, int arg1, int arg2, int arg3, int arg4, int arg5) {}
	public void a(String arg0, double arg1, double arg2, double arg3, double arg4, double arg5, double arg6) {}
	public void b(int arg0, int arg1, int arg2) {}
	
	/*
	 * Initializer functions
	 */
	private WorldEntityWatcher(World world) {
		this.world = world;
		this.refresh();
	}	
	public static WorldEntityWatcher watch(World world) {
		WorldEntityWatcher rval = new WorldEntityWatcher(world);
		if (StackFormer.watcherfield.isValid()) {
			world.addIWorldAccess(rval);
		}
		return rval;
	}
	
	public void refresh() {
		this.items.clear();
		this.orbs.clear();
		for (Object entity : world.entityList) {
			this.a((Entity) entity);
		}
	}
	
	public void remove() {
		if (!StackFormer.watcherfield.isValid()) return;
		List<IWorldAccess> acc = StackFormer.watcherfield.get(this.world);
		if (acc != null) {
			acc.remove(this);
		}
	}
	
	public final World world;
	public final LinkedHashSet<EntityItem> items = new LinkedHashSet<EntityItem>();
	public final LinkedHashSet<EntityExperienceOrb> orbs = new LinkedHashSet<EntityExperienceOrb>();
			
	/*
	 * Adding a new entity
	 */
	@Override
	public void a(Entity e) {
		if (e == null || e.dead) return; 
		if (e instanceof EntityItem) {
			if (!NoLaggItemStacker.isIgnoredItem(e)) {
				this.items.add((EntityItem) e);
			}
		} else if (e instanceof EntityExperienceOrb && NoLaggItemStacker.stackOrbs) {
			this.orbs.add((EntityExperienceOrb) e);
		}
	}
	
	/*
	 * Removing an entity
	 */
	@Override
	public void b(Entity e) {
		if (e == null || e.dead) return; 
		if (e instanceof EntityItem) {
			//don't bother doing an 'ignored item' check as it checks in a map or set anyway
			this.items.remove(e);
		} else if (e instanceof EntityExperienceOrb && NoLaggItemStacker.stackOrbs) {
			this.orbs.remove(e);
		}
	}

}
